//=============================================================================
// 쌠 (C) 2003 ATMEL Corporation
//
// ̧:		MemoryMap.h
// ߲:		WC++߲
// o͗:
// 쐬:		4-Feb-2003	JP (ATMEL̨)
// ύX:		21-Mar-2005 (AESpɕύX)   RAA (ATMELٳ)
//
// xҰ:		avr@atmel.com
//
// :		MemoryMap͈؂̓eAAVRׯ ؓeɍ\
//				MemoryChunk̈ꗗ(޸)łB͔zƂMemoryMap
//				\ŁÂɓ\̂͂̂悤ɂĎgp҂B
//				B
//
// ̑:
//=============================================================================

#ifndef MEMORYMAP_H
#define MEMORYMAP_H

#include "MemoryChunk.h"
#include "DataBuffer.h"
#include <vector>

typedef std::vector<MemoryChunk, std::allocator<MemoryChunk> > MemoryChunkVector;

class MemoryMap : private MemoryChunkVector
{
public:
	MemoryMap(unsigned char emptyFill = 0x00);
	MemoryMap(const char *filename, unsigned int start = 0x00000000,
		unsigned int end = 0xffffffff, unsigned char emptyFill = 0x00);

	virtual ~MemoryMap();

	bool in(unsigned int address);
	unsigned char operator [] (unsigned int address);
	unsigned char at(unsigned int address);
	void insert(MemoryChunk& chunk);
	void insert(unsigned int address, const DataBuffer& buffer);
	unsigned int getLowestAddress();
	unsigned int getHighestAddress();

private:
	unsigned char emptyFillM;			// ؓ̋󂫗̈𖞂lƂĎgp޲
	unsigned int loLimitM;				// ް܂ލŒڽ
	unsigned int hiLimitM;				// ް܂ލōڽ
};

#endif // MEMORYMAP_H
